'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Fetcher = function (_React$PureComponent) {
  _inherits(Fetcher, _React$PureComponent);

  function Fetcher(props) {
    _classCallCheck(this, Fetcher);

    var _this = _possibleConstructorReturn(this, (Fetcher.__proto__ || Object.getPrototypeOf(Fetcher)).call(this, props));

    var fetching = true;

    if (typeof props.handler !== 'function') {
      fetching = false;
    }

    _this.state = {
      fetching: fetching
    };
    return _this;
  }

  _createClass(Fetcher, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var handler = this.props.handler;


      if (typeof handler === 'function') {
        Promise.resolve(handler()).then(function (data) {
          if ((typeof data === 'undefined' ? 'undefined' : _typeof(data)) === 'object') {
            _this2.setState(_extends({}, data, {
              fetching: false
            }));
          } else {
            _this2.setState({
              fetching: false
            });
          }
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          component = _props.component,
          render = _props.render,
          children = _props.children;

      var props = _extends({}, this.state);

      if (component) {
        return _react2.default.createElement(component, props);
      }

      if (render) {
        return render(props);
      }

      if (typeof children === 'function') {
        return children(props);
      }

      if (children && _react2.default.Children.count(children) > 0) {
        return _react2.default.Children.only(children);
      }

      return null;
    }
  }]);

  return Fetcher;
}(_react2.default.PureComponent);

exports.default = Fetcher;